subroutine ApplyStressCorrect

use CommonVars, only: Prec,StressCorrections,NumNodesTotal,      &
   GridIndMat,DispX,DispZ,StressNodeTypes,NumNodesX,NumNodesZ
implicit none
integer :: L,I,J,K,NodeNumber

do L=1,2*NumNodesTotal
   if (L <= NumNodesTotal) then
      I = GridIndMat(L,1)
      J = GridIndMat(L,2)
      K = GridIndMat(L,3)
   elseif (L <= 2*NumNodesTotal) then
      I = GridIndMat(L-NumNodesTotal,1)
      J = GridIndMat(L-NumNodesTotal,2)
      K = GridIndMat(L-NumNodesTotal,3)
   end if

   if (L <= NumNodesTotal) then
      if (StressNodeTypes(I,J,K).ne.'P') then
         DispX(I,J,K) = DispX(I,J,K)+StressCorrections(L)
         write(*,*) 'DispX: ',DispX(I,J,K),I,J,K
      end if
   elseif (L <= 2*NumNodesTotal) then
      if (StressNodeTypes(I,J,K).ne.'P') then
         DispZ(I,J,K) = DispZ(I,J,K)+StressCorrections(L)
         write(*,*) 'DispZ: ',DispZ(I,J,K),I,J,K
      end if
   end if
end do
end
