subroutine CheckDamage(Initialize)

use CommonVars, only: Prec,RockPerms,InitRockPerms,Pres,NumNodesX, &
   NumNodesY,NumNodesZ,Porosities,InitPorosities,Temp,             &
   NumNodesTotal,GridIndMat,ConnectMat,PermChanged
implicit none
real(selected_real_kind(Prec)) :: PresThreshold,PermIncrease, &
   PorosIncrease,TempThreshold,PermSlopeT,PorosSlopeT,RampWidthT
integer :: Initialize,I1,J1,K1,I2,J2,K2,L,M,N,Flag

PresThreshold = 400.D5
TempThreshold = 50.D0
PermIncrease  = 100.D0
PorosIncrease = 1.2D0
RampWidthT = 10.D0
do L=1,NumNodesTotal
   I1 = GridIndMat(L,1)
   J1 = GridIndMat(L,2)
   K1 = GridIndMat(L,3)
   if (Initialize==1) then
      InitRockPerms(I1,J1,K1)  = RockPerms(I1,J1,K1)
      InitPorosities(I1,J1,K1) = Porosities(I1,J1,K1)
      PermChanged(I1,J1,K1) = 0
   else
      Flag = 0
      do N=1,4
         M = ConnectMat(L,N)
         if (M.ne.-1) then
            I2 = GridIndMat(L,1)
            J2 = GridIndMat(L,2)
            K2 = GridIndMat(L,3)
            if (DABS(Temp(I1,J1,K1)-Temp(I2,J2,K2))>TempThreshold) then
               Flag = 1
               PermChanged(I1,J1,K1) = 1
            end if
         end if
      end do
      if ((Flag==1).or.(PermChanged(I1,J1,K1)==1)) then
         !PermSlopeT = InitRockPerms(I1,J1,K1)*(PermIncrease - 1.D0)/ &
         !             RampWidthT
         RockPerms(I1,J1,K1)  = PermIncrease*InitRockPerms(I1,J1,K1)
         !PorosSlopeT = InitPorosities(I,J,K)*(PorosIncrease-1.D0)/ &
         !              RampWidthT
         !Porosities(I,J,K) = PorosSlopeT*(Temp(I,J,K)-TempThreshold) + &
         !                    InitPorosities(I,J,K)
         !RockPerms(I,J,K) = MIN(RockPerms(I1,J1,K1),PermIncrease* &
         !                       InitRockPerms(I1,J1,K1))
         !Porosities(I,J,K) = MIN(Porosities(I,J,K),PorosIncrease* &
         !                        InitPorosities(I,J,K))
      end if
   end if
end do
end
