subroutine TestInvert

use CommonVars, only: Prec
implicit none
real(selected_real_kind(Prec)) :: A(4,3),InvA(3,4),C(4,1),x(3,1),b(4,1), &
   x0,y0,phi

A(1,1) = 1
A(1,2) = 1
A(1,3) = 0.001
A(2,1) = 1
A(2,2) = 2
A(2,3) = 0
A(3,1) = 2
A(3,2) = 1
A(3,3) = 0
A(4,1) = 2
A(4,2) = 2
A(4,3) = 0

x0 = 1.5
y0 = 1.5

b(1,1) = 1
b(2,1) = 1
b(3,1) = 1
b(4,1) = 1

call PseudoInv(A,InvA)

write(*,*) 'pseudo-inverse of A:'
write(*,*) InvA(1,1),InvA(1,2),InvA(1,3),InvA(1,4)
write(*,*) InvA(2,1),InvA(2,2),InvA(2,3),InvA(2,4)
write(*,*) InvA(3,1),InvA(3,2),InvA(3,3),InvA(3,4)
write(*,*)

call MatrixMult(InvA,3,4,b,4,1,x)
call MatrixMult(A,4,3,x,3,1,C)

write(*,*) 'b: '
write(*,*) b(1,1),b(2,1),b(3,1),b(4,1)
write(*,*) 
write(*,*) 'Ax: '
write(*,*) C(1,1),C(2,1),C(3,1),C(4,1)
write(*,*)

call PlaneFit(A,x0,y0,phi)
write(*,*)
write(*,*) 'x: ',x0,'y: ',y0,'phi: ',phi

end
