subroutine CalcStress

use CommonVars, only: Prec,StrainXX,StrainZZ,StrainXZ,StressXX, &
   StressZZ,StressXZ,PoissonRatio,StressGamma,StressBeta,       &
   NumNodesX,NumNodesY,NumNodesZ
implicit none
integer :: I,J,K

do I=1,NumNodesX
   do J=1,NumNodesY
      do K=1,NumNodesZ
         StressXX(I,J,K) = StressGamma(I,J,K)* &
            (1.D0-PoissonRatio(I,J,K))*StrainXX(I,J,K) + &
            StressGamma(I,J,K)*PoissonRatio(I,J,K)*StrainZZ(I,J,K)
         StressZZ(I,J,K) = StressGamma(I,J,K)* &
            (1.D0-PoissonRatio(I,J,K))*StrainZZ(I,J,K) + &
            StressGamma(I,J,K)*PoissonRatio(I,J,K)*StrainXX(I,J,K)
         StressXZ(I,J,K) = StressBeta(I,J,K)*StrainXZ(I,J,K)
      end do
   end do
end do
end
