subroutine SaliCorrect

use CommonVars, only: Prec,NodeNumMat,DeltaX,NumNodesX,NumNodesY, &
   NumNodesZ,Sali,MinSali,MaxSali,NewtonTolX
implicit none
real(selected_real_kind(Prec)) :: SaliResid,Salin,SaliResidDeriv, &
   Correction,Resid,ResidDeriv,NewSali
integer :: I,J,K,NodeNum,IterNum

do I=1,NumNodesX
   do J=1,NumNodesY
      do K=1,NumNodesZ
         NodeNum = NodeNumMat(I,J,K)
         Resid = SaliResid(NodeNum)
         IterNum = 1
         do while ((dabs(Resid)>NewtonTolX).and.(IterNum<=10))
            ResidDeriv = SaliResidDeriv(NodeNum,NodeNum,'X','N')
            Correction = -Resid/ResidDeriv
            NewSali = Sali(I,J,K) + Correction
            if ((NewSali>MinSali).and.(NewSali<MaxSali)) then
               Sali(I,J,K) = NewSali
            else
               IterNum=11
            end if
            Resid = SaliResid(NodeNum)
            IterNum = IterNum + 1
         end do
      end do
   end do
end do
end
