subroutine StressGammaBeta

use CommonVars, only: Prec,StressGamma,StressBeta,YoungModulus,     &
   PoissonRatio,NumNodesX,NumNodesY,NumNodesZ
implicit none
integer :: I,J,K

do I=1,NumNodesX
   do J=1,NumNodesY
      do K=1,NumNodesZ
         StressGamma(I,J,K) = YoungModulus(I,J,K)/ &
            ((1.D0+PoissonRatio(I,J,K))* &
            (1.D0-2.D0*PoissonRatio(I,J,K)))
         StressBeta(I,J,K) = YoungModulus(I,J,K)/ &
            (1.D0+PoissonRatio(I,J,K))
      end do
   end do
end do
end
